package com.spacester.tweetsterupdate.welcome;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.os.Bundle;
import android.widget.Button;

import com.spacester.tweetsterupdate.NightMode;
import com.spacester.tweetsterupdate.R;
import com.spacester.tweetsterupdate.emailAuth.EmailActivity;
import com.spacester.tweetsterupdate.phoneAuth.GenerateOTPActivity;

public class WelcomeActivity extends AppCompatActivity {

    NightMode sharedPref;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        sharedPref = new NightMode(this);
        if (sharedPref.loadNightModeState()) {
            setTheme(R.style.SplashScreenDark);
        } else setTheme(R.style.SplashScreen);
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_welcome);

        //Id
        Button email = findViewById(R.id.email);
        Button phone = findViewById(R.id.phone);

        //OnClick
        email.setOnClickListener(v -> {
            Intent intent = new Intent(getApplicationContext(), EmailActivity.class);
            startActivity(intent);
        });

        phone.setOnClickListener(v -> {
            Intent intent = new Intent(getApplicationContext(), GenerateOTPActivity.class);
            startActivity(intent);
        });

    }
}